from collections import deque, defaultdict

def find_guarded_storages(n, m, k, roads, guards):
   
    g = defaultdict(list)
    for a, b in roads:
        g[a].append(b)
        g[b].append(a)

   
    guarded = set()

   
    for p, h in guards:
        
        q = deque([(p, 0)])  
        visited = set()
        visited.add(p)

        while q:
            current, distance = q.popleft()
            if distance <= h:
                guarded.add(current)
                for neighbor in g[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        q.append((neighbor, distance + 1))

   
    guarded = sorted(guarded)
    return (len(guarded), guarded)


n, m, k = map(int, input().strip().split())
roads = [tuple(map(int, input().strip().split())) for _ in range(m)]
guards = [tuple(map(int, input().strip().split())) for _ in range(k)]


count, guarded_storages = find_guarded_storages(n, m, k, roads, guards)


print(count)
print(' '.join(map(str, guarded_storages)))
